/*******************************************************
 * [EN] AmxModX plugin "Phantom Mod" (phantom_mod.sma)
 * [EN] Author T.Derzinskas slimdog@smail.lt
 * [EN] a.k.a. SlimDog
 * [EN] 
 * [EN] Admin commands
 * [EN] amx_phantom if on turns off, if off turns on.
 * [EN] Free commands
 * [EN] (Say,Say_team) /infofant - info about the mod
 * [EN] The end for now:)
 * 
 *
 * [LT] AmxModX priedas "Fantomo modas"
 * [LT] Autorius T.Derzinskas a.k.a SlimDog
 * [LT] Admino komandos
 * [LT] amx_phantom jei ijungtas isjungia ir atvirksciai
 * [LT] Visu komandos
 * [LT] (Say,Say_team) /infofant - informacija apie moda
 * [LT] Tai tiek siam kartui:P
 *******************************************************/

#include <amxmodx>
#include <cstrike>
#include <fun>

#define PLUGIN "Phantom mod"
#define VERSION "1.2"
#define AUTHOR "SlimDog"

/*********************************************
 * Mod setup 1 - on , 0 - off by default
 *********************************************/

new phstat = 1


new fantomux
public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_dictionary("phantom.txt")
	register_event("RoundTime", "phantom", "bc")
	register_event("SendAudio", "clearpwr", "a","2=%!MRAD_terwin","2=%!MRAD_ctwin","2=%!MRAD_rounddraw")
	register_event("TextMsg","clearpwr","a","2=#Game_Commencing", "2=#Game_will_restart_in")
	register_event("DeathMsg" , "DeathEvent" , "a", "1>0");
	register_concmd("amx_phantom", "phstatus", ADMIN_LEVEL_H)
	register_concmd("say /infofant", "ph_info")
	register_concmd("say_team /infofant", "ph_info")
}

public plugin_precache() 
{
	precache_sound("misc/stinger12.wav")
	return PLUGIN_CONTINUE
}

public client_disconnect(id){
	if (fantomux == id) {
		set_task(0.1,"clearpwr",id)
	}
	return PLUGIN_CONTINUE
}
public client_connect(id){
	if ((phstat == 1) && (fantomux == id)) {
		cs_reset_user_model(id)
		set_user_rendering(id,kRenderFxNone,255,255,255, kRenderNormal,16)
		set_user_health(id,100)
		set_user_armor(id,100)
		set_user_footsteps(id,0)
		set_user_gravity(id,1.0)
	}
	return PLUGIN_CONTINUE
}

public phantom(id)
{
	new players[32], num; 
	get_players(players, num, "a"); 
	if ((phstat == 1) && (num > 1)) {
		new roundtime = get_cvar_num("mp_roundtime") * 60
		if (roundtime != read_data(1))	return PLUGIN_CONTINUE
		new c
		while(!is_user_alive(c))
			c = random_num(1,get_playersnum())
		new fnt[33]
		get_user_name(c,fnt,32)
		new CsTeams:komanda = cs_get_user_team(c)
		fantomux = c
		if( komanda == CS_TEAM_T ) {
			client_cmd(c, "spk misc/stinger12.wav")
			new rand = random_num(0,3)
			switch(rand)
			{
				case 0: cs_set_user_model(c,"gign")
				case 1: cs_set_user_model(c,"gsg9")
				case 2: cs_set_user_model(c,"sas")
				case 3: cs_set_user_model(c,"urban")
			}
			set_user_rendering(c,kRenderFxGlowShell,40,40,40,kRenderTransAlpha,25)
			set_user_health(c,150)
			set_user_armor(c,150)
			set_user_footsteps(c,1)
			set_user_gravity(c,0.7)
			cs_set_user_money(c,cs_get_user_money(c) +2000) 
			set_task(5.0,"glwrndr",c)
			set_hudmessage(200,0,0, 0.03, 0.62, 2, 0.02, 10.0, 0.01, 0.1, 1)
			show_hudmessage(0,"%L",LANG_PLAYER,"T_BECAME_PHANTOM",fnt)
			client_print(c, print_chat, "%L", c, "BECAME_PHANTOM_INFO",fnt)
		}
		if( komanda == CS_TEAM_CT ) {
			client_cmd(c, "spk misc/stinger12.wav")
			new rand = random_num(0,3)
			switch(rand)
			{
				case 0: cs_set_user_model(c,"arctic")
				case 1: cs_set_user_model(c,"leet")
				case 2: cs_set_user_model(c,"terror")
				case 3: cs_set_user_model(c,"guerilla")
			}
			set_user_rendering(c,kRenderFxGlowShell,40,40,40,kRenderTransAlpha,25)
			set_user_health(c,150)
			set_user_armor(c,150)
			set_user_footsteps(c,1)
			set_user_gravity(c,0.7)
			cs_set_user_money(c,cs_get_user_money(c) +2000) 
			set_task(5.0,"glwrndr",c)
			set_hudmessage(200,0,0, 0.03, 0.62, 2, 0.02, 10.0, 0.01, 0.1, 1)
			show_hudmessage(0,"%L",LANG_PLAYER,"CT_BECAME_PHANTOM",fnt)
			client_print(c, print_chat, "%L", c, "BECAME_PHANTOM_INFO",fnt)
		}
		if (id != fantomux) {
			set_user_rendering(id,kRenderFxNone, 255,255,255, kRenderNormal,16);
			cs_reset_user_model(id)
			set_user_footsteps(id,0)
			set_user_gravity(id,1.0)
		}
	}
	return PLUGIN_CONTINUE;
}

public glwrndr(id)
{
	new CsTeams:kmnd = cs_get_user_team(id)
	if( kmnd == CS_TEAM_T ) {
		set_user_rendering(id,kRenderFxNone, 255,255,255, kRenderNormal,16);
		set_user_rendering(id,kRenderFxGlowShell, 255,0,0, kRenderNormal,16)
	}
	if( kmnd == CS_TEAM_CT ) {
		set_user_rendering(id,kRenderFxNone, 255,255,255, kRenderNormal,16);
		set_user_rendering(id,kRenderFxGlowShell, 0,0,255, kRenderNormal,16)
	}
	return PLUGIN_CONTINUE;
}
public clearpwr()
{
	if (fantomux != 0) {
		cs_reset_user_model(fantomux)
		set_user_rendering(fantomux,kRenderFxNone,255,255,255, kRenderNormal,16)
		set_user_health(fantomux,100)
		set_user_armor(fantomux,100)
		set_user_footsteps(fantomux,0)
		set_user_gravity(fantomux,1.0)
		fantomux = 0
	}
	return PLUGIN_CONTINUE;
}
public ph_info(id)
{
	if (phstat == 0) {

		client_print(id, print_chat, "%L", id, "MOD_DONT_WORK")

		return PLUGIN_HANDLED
	}

	client_print(id, print_chat, "%L", id, "INFOFANT_ONE")
	client_print(id, print_chat, "%L", id, "INFOFANT_TWO")

	return PLUGIN_CONTINUE;
}

public phstatus() {
	if (phstat == 1) {
		phstat = 0
		client_print(0, print_chat, "%L", LANG_PLAYER, "ADMIN_TURNED_OFF")
		set_task(0.1,"clearpwr")
	}
	else {
		phstat = 1
		client_print(0, print_chat, "%L", LANG_PLAYER, "ADMIN_TURNED_ON")
	}
	return PLUGIN_CONTINUE
}

public DeathEvent() {
	new phkiller = read_data(1); 
	new phauka = read_data(2);
	new phknm[33]
	new phanm[33]
	new phnm[33]
	get_user_name(phkiller,phknm,32)
	get_user_name(phauka,phanm,32)
	get_user_name(fantomux,phnm,32)
	if (phauka == fantomux) {
		set_hudmessage(31,22,180, 0.03, 0.62, 2, 0.02, 5.0, 0.01, 0.1, 1)
		show_hudmessage(0,"%L",LANG_PLAYER,"KILLING_PHANTOM",phknm,phnm)
		set_task(0.1,"clearpwr",fantomux)
		cs_set_user_money(phkiller,cs_get_user_money(phkiller) +2000)
		client_print(phkiller, print_chat, "%L", phkiller, "KILLED_PHANTOM",phknm)
	}
	if (phkiller == fantomux) {
		cs_set_user_money(phkiller,cs_get_user_money(phkiller) +500)
		client_print(phkiller, print_chat, "%L", phkiller, "KILLING_PHANTOM",phknm)
	}
	return PLUGIN_CONTINUE; 
}
